// FileDropTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FileDropTest.h"
#include "FileDropListCtrl.h"
#include "FileDropTestDlg.h"
#include "hyperlink.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CHyperLink	m_MeLink;
	CHyperLink	m_HyperLink;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_ME, m_MeLink);
	DDX_Control(pDX, IDC_DROPEDIT_LINK, m_HyperLink);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_HyperLink.SetURL(_T("http://www.codeguru.com/editctrl/filedragedit.shtml"));
	m_MeLink.SetURL(_T("mailto:stuartcarter@hotmail.com"));
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CFileDropTestDlg dialog

CFileDropTestDlg::CFileDropTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFileDropTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFileDropTestDlg)
	m_bAcceptFiles = TRUE;
	m_bAcceptDirs = TRUE;
	m_csFileExt = _T(".txt");
	m_nFilterFile = 0;
	m_bAllowDuplicates = FALSE;
	m_bCallback = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFileDropTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFileDropTestDlg)
	DDX_Control(pDX, IDC_ALLOW_DUPS, m_CallbackCheck);
	DDX_Control(pDX, IDC_FILE_EXT, m_FileExt);
	DDX_Control(pDX, IDC_LIST1, m_List);
	DDX_Check(pDX, IDC_ACCEPT_FILES, m_bAcceptFiles);
	DDX_Check(pDX, IDC_ACCEPT_DIRS, m_bAcceptDirs);
	DDX_Text(pDX, IDC_FILE_EXT, m_csFileExt);
	DDX_Radio(pDX, IDC_ALL_FILES_RAD, m_nFilterFile);
	DDX_Check(pDX, IDC_ALLOW_DUPS, m_bAllowDuplicates);
	DDX_Check(pDX, IDC_CALLBACK_BTN, m_bCallback);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFileDropTestDlg, CDialog)
	//{{AFX_MSG_MAP(CFileDropTestDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_EN_KILLFOCUS(IDC_FILE_EXT, UpdateExtension)
	ON_BN_CLICKED(IDC_EMPTY_BTN, OnEmptyBtn)
	ON_WM_SYSCOMMAND()
	ON_BN_CLICKED(IDC_ABOUT, OnAbout)
	//}}AFX_MSG_MAP
	ON_CONTROL_RANGE(BN_CLICKED, IDC_ALL_FILES_RAD, IDC_EXT_RAD, UpdateSettings)
	ON_CONTROL_RANGE(BN_CLICKED, IDC_ACCEPT_FILES, IDC_CALLBACK_BTN, UpdateSettings)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFileDropTestDlg message handlers

void CFileDropTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

/////////////////////////////////////////////////////////////////////////////

void CFileDropTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

/////////////////////////////////////////////////////////////////////////////
// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.

HCURSOR CFileDropTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


/////////////////////////////////////////////////////////////////////////////

void CFileDropTestDlg::OnAbout() 
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();
}

/////////////////////////////////////////////////////////////////////////////

BOOL CFileDropTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon



	//
	// Insert columns into the list control
	//
	// What size do we make them?
	//
	// Need to take account of the width of the vertical scrollbar
	// that windows inserts if the number of items exceeds what can
	// be displayed.  This revents the ugly horizontal scrollbar appearing, 
	//
	RECT listRect;
	m_List.GetClientRect(&listRect);
	int nListWidth = (listRect.right - listRect.left);
	int nVScrollBarWidth = ::GetSystemMetrics(SM_CXVSCROLL); 
	
	int nCol1Width = nListWidth * 0.6;
	int nCol2Width = nListWidth - nCol1Width - nVScrollBarWidth;

	m_List.InsertColumn(0, _T("Pathname"), LVCFMT_LEFT, nCol1Width);
	m_List.InsertColumn(1, _T("Info"), LVCFMT_LEFT, nCol2Width);


	//
	// Set full row selection and an image list
	//
	m_List.SendMessage(LVM_SETEXTENDEDLISTVIEWSTYLE, 0, LVS_EX_FULLROWSELECT);

	m_ImageList.Create(IDR_FILE_IMAGES, 16, 16, RGB(255,0,255));
	m_List.SetImageList(&m_ImageList, LVSIL_SMALL);


	//
	// Specify what we will allow to be dropped onto the list
	//
	CFileDropListCtrl::DROPLISTMODE dropMode;
	dropMode.iMask = CFileDropListCtrl::DL_ACCEPT_FILES | CFileDropListCtrl::DL_ACCEPT_FOLDERS;
	m_List.SetDropMode(dropMode);
	
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////

void CFileDropTestDlg::UpdateSettings(UINT nID) 
{
	nID;
	UpdateData(TRUE);
	GetDlgItem(IDC_ALL_FILES_RAD)->EnableWindow(m_bAcceptFiles);
	GetDlgItem(IDC_EXT_RAD)->EnableWindow(m_bAcceptFiles);
	m_FileExt.EnableWindow(m_bAcceptFiles);

	CFileDropListCtrl::DROPLISTMODE dropMode = m_List.GetDropMode();

	if(m_bAcceptDirs)
		dropMode.iMask |= CFileDropListCtrl::DL_ACCEPT_FOLDERS;
	else
		dropMode.iMask &= ~CFileDropListCtrl::DL_ACCEPT_FOLDERS;


	if(m_bAcceptFiles)
		dropMode.iMask |= CFileDropListCtrl::DL_ACCEPT_FILES;
	else
		dropMode.iMask &= ~CFileDropListCtrl::DL_ACCEPT_FILES;

	if(m_bCallback)
	{
		dropMode.iMask |= CFileDropListCtrl::DL_USE_CALLBACK;
		dropMode.pfnCallback = CFileDropTestDlg::OnListFileDropped;

		// We can't police duplicates if they are inserting items
		// themselves because we don't know which column the filename
		// is in (they might not even display it!)
		m_CallbackCheck.EnableWindow(FALSE);
	}
	else
	{
		dropMode.iMask &= ~CFileDropListCtrl::DL_USE_CALLBACK;
		dropMode.pfnCallback = NULL;
		m_CallbackCheck.EnableWindow(TRUE);
	}

	if(m_bAllowDuplicates)
		dropMode.iMask |= CFileDropListCtrl::DL_ALLOW_DUPLICATES;
	else
		dropMode.iMask &= ~CFileDropListCtrl::DL_ALLOW_DUPLICATES;

	if(1 == m_nFilterFile)
	{
		dropMode.iMask |= CFileDropListCtrl::DL_FILTER_EXTENSION;
		dropMode.csFileExt = m_csFileExt;
	}
	else
		dropMode.iMask &= ~CFileDropListCtrl::DL_FILTER_EXTENSION;

	m_List.SetDropMode(dropMode);
}

/////////////////////////////////////////////////////////////////////////////

void CFileDropTestDlg::UpdateExtension()
{
	UpdateSettings(0);
}

/////////////////////////////////////////////////////////////////////////////

void CFileDropTestDlg::OnEmptyBtn() 
{
	m_List.DeleteAllItems();	
}




/////////////////////////////////////////////////////////////////////////////
// This is the callback used by the list control to notify us of a dropped
// file (as a static member function)

HRESULT CFileDropTestDlg::OnListFileDropped(CListCtrl* pList,
											const CString& csPathname,
											const UINT& iPathType)
{
	// Switch images, depending on the type of path dropped
	int iImage = 0;
	if(CFileDropListCtrl::DL_FOLDER_TYPE == iPathType)
		iImage = 1;

	int nItem = pList->InsertItem(0, csPathname, iImage);
	pList->SetItemText(nItem, 1, _T("Inserted from callback function"));
	return S_OK;
}

/////////////////////////////////////////////////////////////////////////////
// And heres a global version of it, if you like that sort of thing...

HRESULT g_OnListFileDropped(CListCtrl* pList,
							const CString& csPathname,
							const UINT& iPathType)
{
	// Switch images, depending on the type of path dropped
	int iImage = 0;
	if(CFileDropListCtrl::DL_FOLDER_TYPE == iPathType)
		iImage = 1;

	int nItem = pList->InsertItem(0, csPathname, iImage);
	pList->SetItemText(nItem, 1, _T("Inserted from callback function"));
	return S_OK;
}
