// FileDropTestDlg.h : header file
//

#if !defined(AFX_FileDropTestDlg_H__55F58FF9_AD5F_11D3_9DA4_0008C711C6B6__INCLUDED_)
#define AFX_FileDropTestDlg_H__55F58FF9_AD5F_11D3_9DA4_0008C711C6B6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "FileDropListCtrl.h"

//
// Global callback function used when a file is dropped onto
// the list control.
//
// Note:This is not used, only declared to illustrate you can use a
//		global or in this demo, a static member function (OnListFileDropped())
//		
//		Prefer the member version as it keeps it within the class namespace.
//
HRESULT g_FileDropped(CListCtrl* pList, const CString& csPathname, const UINT& iPathType);


/////////////////////////////////////////////////////////////////////////////

class CFileDropTestDlg : public CDialog
{
public:
	CFileDropTestDlg(CWnd* pParent = NULL);

	static HRESULT CALLBACK OnListFileDropped(CListCtrl* pList, const CString& csPathname, const UINT& iPathType);

// Dialog Data
	//{{AFX_DATA(CFileDropTestDlg)
	enum { IDD = IDD_FILEDROPTEST_DIALOG };
	CButton	m_CallbackCheck;
	CEdit	m_FileExt;
	CFileDropListCtrl	m_List;
	BOOL	m_bAcceptFiles;
	BOOL	m_bAcceptDirs;
	CString	m_csFileExt;
	int		m_nFilterFile;
	BOOL	m_bAllowDuplicates;
	BOOL	m_bCallback;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFileDropTestDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CFileDropTestDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnEmptyBtn();
	afx_msg void UpdateExtension();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnAbout();
	//}}AFX_MSG
	afx_msg void UpdateSettings(UINT nID);
	DECLARE_MESSAGE_MAP()

private:
	CImageList m_ImageList;

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FileDropTestDlg_H__55F58FF9_AD5F_11D3_9DA4_0008C711C6B6__INCLUDED_)
